<template>
  <v-card width="450px" height="400px" class="pa-4">
    <v-row class="justify-center">
      <v-col
        align="left"
        class="flex-grow-0 text-no-wrap d-flex align-center pr-0"
      >
        <h3>{{ title }}</h3>
      </v-col>
      <v-col class="align-center d-flex align-end pl-0">
        <span class="period-value"> {{ period }}</span>
      </v-col>
      <v-col align="right">
        <SettingChart
          @edit:chart="editHandler"
          @delete:chart="deleteHandler"
          @duplicate:chart="onDuplicateHandler"
        />
      </v-col>
    </v-row>
    <v-row>
      <v-col>
        <Line id="line-chart" :data="data" :options="options" />
      </v-col>
    </v-row>
  </v-card>
</template>

<script>
import SettingChart from "./SettingChart.vue";
import {
  Chart as ChartJS,
  CategoryScale,
  LinearScale,
  PointElement,
  LineElement,
  Title,
  Tooltip,
  Legend,
} from "chart.js";

ChartJS.register(
  CategoryScale,
  LinearScale,
  PointElement,
  LineElement,
  Title,
  Tooltip,
  Legend
);

import { Line } from "vue-chartjs";
export default {
  name: "LineChart",
  emits: ["edit:chart", "delete:chart", "duplicate:chart"],
  props: {
    data: Object,
    options: Object,
    title: String,
    id: Number,
    period: String,
  },
  components: {
    Line,
    SettingChart,
  },
  methods: {
    onDuplicateHandler() {
      this.$emit("duplicate:chart", this.id);
    },
    editHandler() {
      this.$emit("edit:chart", this.id);
    },
    deleteHandler() {
      this.$emit("delete:chart", this.id);
    },
  },
};
</script>

<style scoped>
.period-value {
  font-size: 12px;
  margin-left: 5px;
  color: #7f7c7c;
  margin-top: 4px;
}
</style>